<!DOCTYPE html>
<html>
  <head>
    <title>CMSC 6950</title>
    <meta charset="utf-8">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
	  <link rel="stylesheet" href="https://cdn.pydata.org/bokeh/release/bokeh-1.1.0.min.css" type="text/css" />
    <style>
      @import url(https://fonts.googleapis.com/css?family=Yanone+Kaffeesatz);
      @import url(https://fonts.googleapis.com/css?family=Droid+Serif:400,700,400italic);
      @import url(https://fonts.googleapis.com/css?family=Ubuntu+Mono:400,700,400italic);

      body {
        font-family: 'Droid Serif';
        font-size: medium;
      }
      .remark-container{
        background-image:url('tools.png');
        background-repeat:no-repeat;
        background-size: cover;
      }
      h1, h2, h3 {
        font-family: 'Yanone Kaffeesatz';
        font-weight: 400;
        margin-bottom: 0;
      }
      .small * {
        font-size: small !important;
      }
      code {
        border-radius: 5px;
      }
      .inverse {
        background: #272822;
        color: #777872;
        text-shadow: 0 0 20px #333;
      }
      .inverse h1, .inverse h2 {
        color: #f3f3f3;
        line-height: 0.8em;
      }
      .footnote {
        position: absolute;
        font-size: large;
        bottom: 3em;
        right: 3em;
      }
      /* styling only necessary for displaying source */
      #source {
        position: absolute;
        display: none;
        font-family: monospace;
        font-size: medium;
        background: #333333;
        color: white;
        padding: 10px;
        text-align: left;
        width: 65%;
        height: 70%;
        z-index: 1000;
      }
      #overlay {
        position: absolute;
        display: none;
        background: black;
        width: 100%;
        height: 100%;
        opacity: 0.2;
        z-index: 999;
      }
      a{
        color: orange;
      }
      h1#title {
        margin-top: 100px;
        margin-bottom: 30px;
      }
    </style>
	<script src="https://remarkjs.com/downloads/remark-latest.min.js"></script>
	<script type="text/javascript" src="https://cdn.pydata.org/bokeh/release/bokeh-1.1.0.min.js"></script>
    
  </head>
  <body onload="var slideshow = remark.create();">
    <textarea id="source" readonly>

class: center, middle, inverse

# Stack Overflow Developer Survey
## 2018


.footnote[ by [Group 4](https://gitlab.com/cmsc6950/team4/SOSV)
]
---


<div class="container" style="width: 100%; height: 100vh; margin: 0px">
  <div class="row">
    <div class="col">
      <h1 id="title" >Agenda</h1>
      <h3>
              1. Introduction          <br/>
              2. Retrieving the Data   <br/> 
              3. Data Exploration      <br/>
              4. Conclusion            <br/>
          </h3>
      </div>
      <div 
        class="col" 
        style="height:67vh; width: 200px; background-size: cover; background-image: url(https://www.northeastern.edu/graduate/blog/wp-content/uploads/2019/01/chart-data-desk-590022.jpg);"
          />
      </div>
    </div>
  </div>


---

<h1 id="title" >1. Introduction</h1>


Each year, Stack Overflow ask the developer community 
about everything from their favorite technologies to their 
job preferences. 2018, was the year with the largest number of 
respondents. Over 100,000 developers took the 30-minute survey 
in January 2018.

<br/>
.center[
  <img 
    src="https://cdn-images-1.medium.com/max/1600/1*yg2DHASe7om_TsIz0E5UuA.png" 
    height="200" />
]


---
<h1 id="title" >Contributions</h1>

<table class="table">
  <thead>
    <tr>
      <th>Name</th>
      <th>Initial</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td>Umar Shaik</td>
      <td>US</td>
    </tr>
    <tr>
      <td>Ruben Chevez</td>
      <td>RC</td>
    </tr>
    <tr>
      <td>Samira Saki</td>
      <td>SS</td>
    </tr>
    <tr>
      <td>Asma Javaid</td>
      <td>AJ</td>
    </tr>
    <tr>
      <td>Osarobo Ogbeide</td>
      <td>OO</td>
    </tr>
  </tbody>
</table>

---

<h1 id="title" >Contributions</h1>

<table class="table">
  <thead>
    <tr>
      <th>Task</th>
      <th>Initials</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td> 
        Download Data    <br/> 
        Clean Data       <br/>
        Clean Repository <br/>
        Unit Testing  
      </td>
      <td>US, RC </td>
    </tr>
    <tr>
      <td>
        Bokeh & Matplotlib Visualization
      </td>
      <td>US, RC, SS</td>
    </tr>
    <tr>
      <td>Presentation & Documentation</td>
      <td>US, RC, AJ, OO, SS</td>
    </tr>
    <tr>
      <td>Make File Execution </td>
      <td>US, RC, OO </td>
    </tr>
  </tbody>
</table>

---


<h1 id="title" >2.1 Data</h1>
<h4>
The Stack Overflow Developer Survey contains over 129 data fields. We filtered and used the following:
</h4>
<br/>
<div class="container">
  <div class="row">
    <div class="col">Respondent</div>
    <div class="col"> YearsCodingProf </div>
    <div class="col"> YearsCoding </div>
    <div class="col"> Employment </div>
  </div>
  <div class="row">
    <div class="col"> FormalEducation </div>
    <div class="col"> Country </div>
    <div class="col"> OpenSource </div>
    <div class="col"> JobSatisfaction </div>
  </div>
  <div class="row">
    <div class="col"> UndergradMajor </div>
    <div class="col"> DevType </div>
    <div class="col"> Currency </div>
    <div class="col"> Salary </div>
  </div>
  <div class="row">
    <div class="col"> ConvertedSalary </div>
    <div class="col"> CurrencySymbol </div>
    <div class="col"> SalaryType </div>
    <div class="col"> IDE </div>
  </div>
  <div class="row">
    <div class="col"> LanguageWorkedWith </div>
    <div class="col"> FrameworkWorkedWith </div>
  </div>
</div>

---



<div class="container" style="width: 100%; height: 100vh; margin: 0px">
  <div class="row">
    <div class="col">
      <h1 id="title" >2.2. Makefile</h1>
      <h4>
        Running the <strong>make</strong> command will execute the following steps:
      </h4>
      <br/>
      <h5>
              1. Install <strong>pipenv</strong>               <br/>
              2. Install the python packages                   <br/> 
              3. Run <strong>python download.py</strong>       <br/>
              4. Run <strong>python download.py</strong>       <br/>
              5. Run <strong>python cleandata.py</strong>      <br/>
              6. Run <strong>python visualization.py</strong>  <br/>
      </h5>
    </div>
    <div 
      class="col" 
      style="height:67vh; width: 200px; background-size: cover; background-image: url(https://images5.alphacoders.com/695/695933.jpg);"
    ></div>
  </div>
</div>



---

<div class="container" style="width: 100%; height: 100vh; margin: 0px">
  <div class="row">
    <div class="col">
      <h1 id="title" >2.3. Download Data</h1>
      <h4>
        The 
        <strong>download.py</strong> 
        file generates the 
        <strong>download_data.csv</strong> 
        with all the unfiltered data from Kaggle.
        <br/>
        <br/>
        The kaggle API python package and the Kaggle credentials
        are necessary to download the data.
      </h4>
    </div>
    <div 
      class="col" 
      style="height:67vh; width: 200px; background-size: cover; background-image: url(https://i.pinimg.com/originals/f2/e4/63/f2e4635353c0d4e70f970293b8208913.jpg);"
    ></div>
  </div>
</div>

---


<div class="container" style="width: 100%; height: 100vh; margin: 0px">
  <div class="row">
    <div class="col">
      <h1 id="title" >2.4. Clean the data</h1>
      <h4>
        The 
        <strong>cleandata.py</strong> 
        file generates the 
        <strong>clean_data.csv</strong> file
        with only the desired columns, filters the empty rows, converts the salary to a standard format and single currency.
      </h4>
    </div>
    <div 
      class="col" 
      style="height:67vh; width: 200px; background-size: cover; background-image: url(https://cdn.foodlogistics.com/files/base/acbm/fl/image/2015/04/960w/data_funnel.5525242768109.jpg);"
    ></div>
  </div>
</div>

---


<div class="container" style="width: 100%; height: 100vh; margin: 0px">
    <div class="row">
      <div class="col">
        <h1 id="title" >2.5. Render the data</h1>
        <h4>
          The 
          <strong>visualization.py</strong> and
          <strong>bokehVisualization.py</strong> 
          files generates all the plots in image and html format in the
          <strong>public/html</strong>
          and          
          <strong>public/images</strong>
          directories.
        </h4>
      </div>
      <div 
        class="col" 
        style="height:67vh; width: 200px; background-size: cover; background-image: url(https://wallup.net/wp-content/uploads/2016/01/275529-digital_art-abstract-CGI-render-pattern-colorful-warm_colors-spectrum-748x421.png);"
      ></div>
    </div>
  </div>

---

# 3.1 Country Pie Chart
In this survey we have respondents from more than 180 countries but most of the respondents are from The United States and India. 


<object width="800" height="420" type="text/html" data="html/CountryPiechart.html" border="1" >
</object>

---

# 3.2 Mean Salary by Country
Mean salary range distribution with respect to countries.

<object width="800" height="450" type="text/html" data="html/JobSatisfactionByCountry.html" border="1" >
</object>

---

# 3.3 Average Salary by Country
The bar chart below shows that countries who have respondents of 100 or more have lower salary number:
* Ireland and United states respondents have salaries more than $100,000.
* Norway, United Kingdom and Switzerland more than $80,000, while
* Canada, Denmark and France are between $60,000 to $80,000.

<object width="800" height="350" type="text/html" data="html/AvgSalarybyCountryBar.html" border="1" >
</object>

---

# 3.4 Salary Box
* An Engineering Manager got the maximum salary of more than $8,000 while 
* A Developer Specialist got a salary ranging from $40,000 to $75,000.

<object width="780" height="420" type="text/html" data="html/SALARYBOX.html" border="1" >
</object>

---

# 3.5 Employment Status
From the pie chart plot below, around 75.24% developers are employed as full time while 9.85% work as a freelancer or self employed.

<object width="800" height="420" type="text/html" data="html/EmploymentPiechart.html" border="1" >
</object>

---

# 3.6 Formal Education
The main respondents have Bachelor's degree followed by Master's degree holders.
<object width="800" height="440" type="text/html" data="html/FormalEducationBar.html" border="1" >
</object>

---

# 3.7 Programming Language
The graph shows that most of the respondents used JavaScript, HTML and CSS as their preferred programming language.
<object width="800" height="440" type="text/html" data="html/LanguageWorkedWithBar.html" border="1" >
</object>

---

# 3.8 Developer Type
This chart shows that the major respondents are full-stack developers followed by Desktop/Enterprise Applications developers and Student developers.
<object width="800" height="420" type="text/html" data="html/DevTypebar.html" border="1" >
</object>

---

# 3.9 Framework
From the survey carried out, Node.js, Angular, and React are the most popular frameworks which developers worked with in the year 2018, 
while Spring, TensorFlow and Hadoop were less appealing to most developers.
<object width="800" height="420" type="text/html" data="html/FrameworkWorkedWithBar.html" border="1" >
</object>

---

# 3.10 Languages Correlation
This graph shows the Programming Languages correlating with one another. E.g JavaScript users have higher usage of HTML, CSS and SQL.
<object width="800" height="420" type="text/html" data="html/LanguageCorrelation.html" border="1" >
</object>

---

# 3.11 OpenSource
The pie chart plot shows the number of developers that worked with open source tools.
* Approx. 56 % developers did not work with open source tools, while
* Approx. 44 % developers worked with open source tools.

<object width="760" height="370" type="text/html" data="html/OpenSourcePiechart.html" border="1" >
</object>

---

# 3.12 Normal Distribution Years of Coding
As shown in the normal distribution below the average years of coding is 6 years. More details will be shown in the next plot.
<object width="800" height="420" type="text/html" data="html/YearsCodingNormalDistribution.html" border="1" >
</object>

---

# 3.13 Years of Coding Professionally
The plot below shows that:
* The maximum number of years developers coded professionally is 26 years.
* The average developer coded professionally for about 6 years.
* 50% of the developers coded professionally between 3 - 12 years.

<object width="800" height="350" type="text/html" data="html/YearsCodingProfboxplot.html" border="1" >
</object>

---

# 3.14 Job Satisfaction
The pie chart shows the levels of job satisfaction of people with their current job.

* 37.5 % are Moderately satisfied, 17.9 % are Extremely satisfied, 14.5 % are Slightly satisfied and 10.2 % are Slightly dissatisfied.

<object width="800" height="370" type="text/html" data="html/JobSatisfactionPiechart.html" border="1" >
</object>

---

# 3.15 Job Satisfaction By Country
This shows the country wise distribution of the job satisfaction as explained earlier in the pie chart.

* 11,670 developers in The United States are satisfied while 5,172 developers in India are satisfied.
* 1,811 developers in Canada and 1,155 developers in Brazil are satisfied.

<object width="800" height="350" type="text/html" data="html/JobSatisfactionByCountry.html" border="1" >
</object>

---

# 4. Conclusion
The survey analysis based on 98,855 developers from more than 180 countries shows that:

* The United States have more respondents with 21.728% while India had 13.05% respondents, Germany 6.625%, United Kingdom 6.596% and Canada 3.525%.
* Ireland and United States respondents have salaries more than $100,000. Norway, United Kingdom and Switzerland respondents have salary more than $80,000, while Canada, Denmark and France have salary range between $60,000 to $80,000.
* About 9.85% developers work as a freelancers or self employed, 5.65% are not employed and looking for work, 5.38% are employed as part time.
* Approximately 40,000 developers have Bachelor's degree while 20,000 developers have Master's degree, about 11,000 have some college/university education without earning a degree and about 2,000 have other doctoral degree e.g PhD.
* Node.js, Angular, and React are the most popular frameworks which developers worked with in the year 2018.
  </textarea>  
  
    
   </body>
</html>